Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 184434 - openssh-4.6_p1-r2 fails to compile with uclibc when USE=pam due to stdio.h always including pthread.h
Summary: openssh-4.6_p1-r2 fails to compile with uclibc when USE=pam due to stdio.h al...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Embedded Gentoo Team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2007-07-06 17:57 UTC by Wolfgang Thiess
Modified: 2010-01-16 16:34 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
The error messages of net-misc/openssh-5.1_p1-r1 (ssh_err,17.13 KB, text/plain)
2008-11-04 21:17 UTC, Tobias Leupold
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Wolfgang Thiess 2007-07-06 17:57:49 UTC
My system is a Linksys NSLU2 (xscale armv5teb - big endian).

I used uclibc-0.9.28.1 when emerging openssh-4.6_p1-r2.

After upgrading to uclibc-0.9.28.3 I re-emerged openssh-4.6_p1-r2 getting this error:

root@TINYSERV ~ # emerge -v openssh

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ] net-misc/openssh-4.6_p1-r2  USE="pam -X -X509 -chroot -hpn -kerberos -ldap -libedit (-selinux) -skey -smartcard -static -tcpd" 0 kB

Total: 1 package (1 reinstall), Size of downloads: 0 kB
[...]
armeb-softfloat-linux-uclibc-gcc -march=armv5t -Os -Wall -Wpointer-arith -Wuninitialized -Wsign-compare -std=gnu99  -I. -I.  -DSSHDIR=\"/etc/ssh\" -D_PATH_SSH_PROGRAM=\"/usr/bin/ssh\" -D_PATH_SSH_ASKPASS_DEFAULT=\"/usr/lib/misc/ssh-askpass\" -D_PATH_SFTP_SERVER=\"/usr/lib/misc/sftp-server\" -D_PATH_SSH_KEY_SIGN=\"/usr/lib/misc/ssh-keysign\" -D_PATH_SSH_PIDDIR=\"/var/run\" -D_PATH_PRIVSEP_CHROOT_DIR=\"/var/empty\" -DSSH_RAND_HELPER=\"/usr/lib/misc/ssh-rand-helper\" -DHAVE_CONFIG_H -c auth-pam.c
auth-pam.c:172: warning: static declaration of 'pthread_exit' follows non-static declaration
/usr/include/pthread.h:179: warning: previous declaration of 'pthread_exit' was here
auth-pam.c:180: error: conflicting types for 'pthread_create'
/usr/include/pthread.h:169: error: previous declaration of 'pthread_create' was here
auth-pam.c:180: error: conflicting types for 'pthread_create'
/usr/include/pthread.h:169: error: previous declaration of 'pthread_create' was here
auth-pam.c:205: error: conflicting types for 'pthread_cancel'
/usr/include/pthread.h:612: error: previous declaration of 'pthread_cancel' was here
auth-pam.c:205: error: conflicting types for 'pthread_cancel'
/usr/include/pthread.h:612: error: previous declaration of 'pthread_cancel' was here
auth-pam.c:213: error: conflicting types for 'pthread_join'
/usr/include/pthread.h:184: error: previous declaration of 'pthread_join' was here
auth-pam.c:213: error: conflicting types for 'pthread_join'
/usr/include/pthread.h:184: error: previous declaration of 'pthread_join' was here
make: *** [auth-pam.o] Error 1
[...]
root@TINYSERV ~ # emerge --info
Portage 2.1.2.7 (uclibc/arm, gcc-3.4.6, uclibc-0.9.28.3-r0, 2.6.16 armv5teb)
=================================================================
System uname: 2.6.16 armv5teb XScale-IXP42x Family rev 1 (v5b)
Gentoo Base System release 1.12.9
Timestamp of tree: Fri, 06 Jul 2007 15:00:01 +0000
dev-lang/python:     2.4.4-r4
dev-python/pycrypto: 2.0.1-r5
sys-apps/sandbox:    1.2.17
sys-devel/autoconf:  2.13, 2.61
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10
sys-devel/binutils:  2.17
sys-devel/gcc-config: 1.3.16
sys-devel/libtool:   1.5.22
virtual/os-headers:  2.6.11-r2
ACCEPT_KEYWORDS="arm"
AUTOCLEAN="yes"
CBUILD="armeb-softfloat-linux-uclibc"
CFLAGS="-march=armv5t -Os"
CHOST="armeb-softfloat-linux-uclibc"
CONFIG_PROTECT="/etc"
CONFIG_PROTECT_MASK="/etc/env.d /etc/gconf /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/revdep-rebuild /etc/terminfo"
CXXFLAGS="-march=armv5t -Os"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig ccache distlocks metadata-transfer sandbox sfperms strict"
GENTOO_MIRRORS="http://distfiles.gentoo.org http://distro.ibiblio.org/pub/linux/distributions/gentoo"
MAKEOPTS="-j1"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_EXTRA_OPTS="--exclude-from=/etc/portage/rsync_excludes --timeout=500"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --delete-after --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --filter=H_**/files/digest-*"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="arm cli cracklib dri jpeg midi mudflap ncurses openmp pam pcre readline reflection session spl uclibc xorg zlib" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" ELIBC="uclibc" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" USERLAND="GNU" VIDEO_CARDS="dummy fbdev v4l"
Unset:  CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, LDFLAGS, LINGUAS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTDIR_OVERLAY
Comment 1 Tobias Leupold 2008-10-12 18:19:35 UTC
Same problem here with net-misc/openssh-4.7_p1-r6:

armeb-softfloat-linux-uclibc-gcc -march=armv5t -mtune=xscale -Os -Wall -Wpointer-arith -Wuninitialized -Wsign-compare -Wno-pointer-sign -std=gnu99  -I. -I.  -DSSHDIR=\"/etc/ssh\" -D_PATH_SSH_PROGRAM=\"/usr/bin/ssh\" -D_PATH_SSH_ASKPASS_DEFAULT=\"/usr/lib/misc/ssh-askpass\" -D_PATH_SFTP_SERVER=\"/usr/lib/misc/sftp-server\" -D_PATH_SSH_KEY_SIGN=\"/usr/lib/misc/ssh-keysign\" -D_PATH_SSH_PIDDIR=\"/var/run\" -D_PATH_PRIVSEP_CHROOT_DIR=\"/var/empty\" -DSSH_RAND_HELPER=\"/usr/lib/misc/ssh-rand-helper\" -DHAVE_CONFIG_H -c auth-pam.c
auth-pam.c:172: error: static declaration of 'pthread_exit' follows non-static declaration
/usr/include/pthread.h:179: error: previous declaration of 'pthread_exit' was here
auth-pam.c:180: error: conflicting types for 'pthread_create'
/usr/include/pthread.h:169: error: previous declaration of 'pthread_create' was here
auth-pam.c:205: error: conflicting types for 'pthread_cancel'
/usr/include/pthread.h:612: error: previous declaration of 'pthread_cancel' was here
auth-pam.c:213: error: conflicting types for 'pthread_join'
/usr/include/pthread.h:184: error: previous declaration of 'pthread_join' was here
make: *** [auth-pam.o] Error 1
 *
 * ERROR: net-misc/openssh-4.7_p1-r6 failed.
 * Call stack:
 *               ebuild.sh, line   49:  Called src_compile
 *             environment, line 3083:  Called die
 * The specific snippet of code:
 *       emake || die "compile problem"
 *  The die message:
 *   compile problem
 *
 * If you need support, post the topmost build error, and the call stack if relevant.
 * A complete build log is located at '/var/log/portage/net-misc:openssh-4.7_p1-r6:20081012-172959.log'.
 * The ebuild environment file is located at '/var/tmp/portage/net-misc/openssh-4.7_p1-r6/temp/environment'.
 *

emerge --info:

Portage 2.1.4.4 (uclibc/arm, gcc-4.1.2, uclibc-0.9.28.3-r7, 2.6.21.7 armv5teb)
=================================================================
System uname: 2.6.21.7 armv5teb XScale-IXP42x Family rev 2 (v5b)
Timestamp of tree: Sat, 11 Oct 2008 23:15:04 +0000
distcc 2.18.3 armeb-softfloat-linux-uclibc (protocols 1 and 2) (default port 3632) [disabled]
app-shells/bash:     3.2_p33
dev-lang/python:     2.4.4-r6
dev-python/pycrypto: 2.0.1-r6
sys-apps/baselayout: 1.12.11.1
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.61-r2
sys-devel/automake:  1.10.1
sys-devel/binutils:  2.18-r3
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.26
virtual/os-headers:  2.6.23-r3
ACCEPT_KEYWORDS="arm"
CBUILD="armeb-softfloat-linux-uclibc"
CFLAGS="-march=armv5t -mtune=xscale -Os"
CHOST="armeb-softfloat-linux-uclibc"
CONFIG_PROTECT="/etc"
CONFIG_PROTECT_MASK="/etc/env.d /etc/gconf /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/revdep-rebuild /etc/terminfo /etc/udev/rules.d"
CXXFLAGS="-march=armv5t -mtune=xscale -Os"
DISTDIR="/usr/src/distfiles"
FEATURES="autoconfig distlocks metadata-transfer nodoc noinfo noman parallel-fetch sandbox sfperms strict unmerge-orphans userfetch userpriv usersandbox"
GENTOO_MIRRORS="         http://linux.rz.ruhr-uni-bochum.de/download/gentoo-mirror/         http://ftp.belnet.be/mirror/rsync.gentoo.org/gentoo/ "
LANG="de_DE.UTF-8"
LC_ALL="de_DE.UTF-8"
LDFLAGS="-Wl,-O1"
LINGUAS="de"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/var/portage/tree"
PORTDIR_OVERLAY="/var/portage/local"
SYNC="rsync://rsync.europe.gentoo.org/gentoo-portage"
USE="arm cli cracklib crypt dri midi mudflap ncurses openmp pam pcre perl python readline reflection session spl ssl tcpd uclibc unicode vim-syntax xorg zlib" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" ELIBC="uclibc" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="de" USERLAND="GNU" VIDEO_CARDS="dummy fbdev v4l"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, MAKEOPTS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 2 SpanKY gentoo-dev 2008-11-03 08:25:12 UTC
uClibc's stdio should not be polluting namespace by pulling in pthread.h all the time ...
Comment 3 Tobias Leupold 2008-11-03 08:55:03 UTC
By now, openssh-4.7_p1-r6 compiles on my NSLU2.
Comment 4 Tobias Leupold 2008-11-04 21:17:13 UTC
The current stable version (net-misc/openssh-5.1_p1-r1) fails again.
Comment 5 Tobias Leupold 2008-11-04 21:17:40 UTC
Created attachment 170745 [details]
The error messages of net-misc/openssh-5.1_p1-r1
Comment 6 SpanKY gentoo-dev 2008-11-17 22:38:26 UTC
that is bug 244776.  if the original issue is resolved, close this bug.
Comment 7 Tobias Leupold 2008-11-18 20:03:06 UTC
Works for me with net-misc/openssh-5.1_p1-r2
Comment 8 Tobias Leupold 2008-11-18 21:22:55 UTC
P.S.: still fails with USE="pam":

armeb-softfloat-linux-uclibc-gcc -march=armv5t -mtune=xscale -Os -Wall -Wpointer-arith -Wuninitialized -Wsign-compare -Wno-pointer-sign -Wformat-security -fno-builtin-memset -std=gnu99  -I. -I.  -DSSHDIR=\"/etc/ssh\" -D_PATH_SSH_PROGRAM=\"/usr/bin/ssh\" -D_PATH_SSH_ASKPASS_DEFAULT=\"/usr/lib/misc/ssh-askpass\" -D_PATH_SFTP_SERVER=\"/usr/lib/misc/sftp-server\" -D_PATH_SSH_KEY_SIGN=\"/usr/lib/misc/ssh-keysign\" -D_PATH_SSH_PIDDIR=\"/var/run\" -D_PATH_PRIVSEP_CHROOT_DIR=\"/var/empty\" -DSSH_RAND_HELPER=\"/usr/lib/misc/ssh-rand-helper\" -DHAVE_CONFIG_H -c auth-pam.c
auth-pam.c:172: error: static declaration of 'pthread_exit' follows non-static declaration
/usr/include/pthread.h:179: error: previous declaration of 'pthread_exit' was here
auth-pam.c:180: error: conflicting types for 'pthread_create'
/usr/include/pthread.h:169: error: previous declaration of 'pthread_create' was here
auth-pam.c:205: error: conflicting types for 'pthread_cancel'
/usr/include/pthread.h:612: error: previous declaration of 'pthread_cancel' was here
auth-pam.c:213: error: conflicting types for 'pthread_join'
/usr/include/pthread.h:184: error: previous declaration of 'pthread_join' was here
make: *** [auth-pam.o] Error 1

With USE="-pam", it builds. But this is a PAM issue, I think.
Comment 9 SpanKY gentoo-dev 2008-11-18 21:31:51 UTC
nope, that's the same error as the original report ... i thought it odd that it seemed to "disappear" since none of the code in question changed
Comment 10 Tobias Leupold 2010-01-16 16:34:36 UTC
Still exactly the same error with net-misc/openssh-5.3_p1-r1